!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module DistrbPrm
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: distrbprm.f90,v 1.2 2005/01/28 12:41:21 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!νͤץ distrb νͤꤹ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!顼 gf4f90io 
!
                                                                 !=end

module distrbprm
  !--- ۤηػ
  implicit none

  !--- save °
  save
                                                                 !=begin
  !--- ѿ
  real(8)       :: CpDry            !Ǯ
  real(8)       :: MolWtDry         !ʬ

  character(80) :: ExnerDistrbType  !̵Ϥξ (DistrbType.f90 )
  real(8)       :: ExnerSigmaX      ! (X )
  real(8)       :: ExnerSigmaZ      ! (Z )
  real(8)       :: ExnerMax         !κ
  real(8)       :: ExnerCenterX     !濴 (X )
  real(8)       :: ExnerCenterZ     !濴 (X )

  character(80) :: PotTempDistrbType  !̤ξ (DistrbType.f90 )
  real(8)       :: PotTempSigmaX      ! (X )
  real(8)       :: PotTempSigmaZ      ! (X )
  real(8)       :: PotTempMax         !κ
  real(8)       :: PotTempCenterX     !濴 (X )
  real(8)       :: PotTempCenterZ     !濴 (X )

  character(80) :: VelDistrbType    !®٤ξ (DistrbType.f90 )
  real(8)       :: VelX             !® u 
  real(8)       :: VelZ             !® w

  character(80) :: distrbfile       !ϥե̾
                                                                 !=end

contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST νץ distrb ɤ߼. 
  !
  subroutine distrbprm_init(cfgfile)

    !=== Input
    character(*), intent(in) :: cfgfile

    !=== NAMELIST
    NAMELIST /distrbprm/ &
         & distrbfile, CpDry, MolWtDry, &
         & ExnerDistrbType, ExnerMax, ExnerSigmaX, ExnerSigmaZ, &
         &                  ExnerCenterX, ExnerCenterZ, &
         & PotTempDistrbType, PotTempMax, PotTempSigmaX, PotTempSigmaZ, &
         &                  PotTempCenterX, PotTempCenterZ, &
         & VelDistrbType, VelX, VelZ

    open (10, FILE=cfgfile)
    read(10, NML=distrbprm)
    close(10)
                                                                 !=end    
    !--- ѿͤΥå
    if ( ExnerSigmaX > 1 )  then 
       write(*,*) "gacchanprm.f90: SigmaX is > 1. "
       stop
    end if

    if ( ExnerSigmaZ > 1 )  then
       write(*,*) "gacchanprm.f90: SigmaZ is > 1. "
       stop
    end if

    if ( PotTempSigmaX > 1 )  then 
       write(*,*) "gacchanprm.f90: SigmaX is > 1. "
       stop
    end if

    if ( PotTempSigmaZ > 1 )  then
       write(*,*) "gacchanprm.f90: SigmaZ is > 1. "
       stop
    end if

    if ( ExnerCenterX > 1 ) then 
       write(*,*) "gacchanprm.f90: CenterX is > 1. "
       stop
    end if

    if ( ExnerCenterZ > 1 ) then
       write(*,*) "gacchanprm.f90: CenterZ is > 1. "
       stop
    end if

    if ( PotTempCenterX > 1 ) then 
       write(*,*) "gacchanprm.f90: CenterX is > 1. "
       stop
    end if

    if ( PotTempCenterZ > 1 ) then
       write(*,*) "gacchanprm.f90: CenterZ is > 1. "
       stop
    end if

  end subroutine distrbprm_init
  
end module distrbprm
